package stackjava.com.reflection;

import java.lang.reflect.Field;

public class Demo {
	public static void main(String[] args) {
		Customer customer = new Customer();
		customer.setAge(25);
		customer.setGender("Male");
		customer.setName("kai");
		customer.setPhone("034xxxxxxx");
		
		Customer newCustomer = (Customer) clone(customer);
		System.out.println(newCustomer);
		
		Player player = new Player();
		player.setName("Neuer");
		player.setTeam("Bayer");
		player.setPosition("Goal Keeper");
		
		Player newPlayer = (Player) clone(player);
		System.out.println(newPlayer);
	}

	public static Object clone(Object object) {
		try {
			Class<?> myClass = object.getClass();
			Object newObject = myClass.newInstance();
//			Object newObject = myClass.getConstructor().newInstance();

			Field[] allFields = myClass.getDeclaredFields();
			for (Field field : allFields) {
				field.setAccessible(true);
				field.set(newObject, field.get(object));
			}
			return newObject;
		} catch (Exception e) {
			System.out.println(e);
			return null;
		}
	}
	
}
